<?php

namespace Alike\Admin;

/**
*
*/
class Ra_Admin_AJAX {

  public function __construct() {
    add_action( 'wp_ajax_alike_compare_table', [$this, 'alike_compare_table'] );
    add_action( 'wp_ajax_alike_compare_add_post', [$this, 'alike_compare_add_post'] );
    add_action( 'wp_ajax_alike_compare_remove_post', [$this, 'alike_compare_remove_post'] );
   }
public function alike_compare_table() {
  if ( ! wp_verify_nonce( $_REQUEST['nonce'], 'builder_nonce' ) ) {
    wp_send_json_error( [
        'message' => __( 'Nonce verification failed!', 'alike' )
    ] );
    return;
   }
  $alike_saved_post_types = get_option( 'alike_saved_post_types' ) == '' ? [] : get_option( 'alike_saved_post_types' );
    $args       = array(
      'public' => true,
    );
    $post_types = get_post_types( $args, 'objects' );
    $all_post_type = [];    

    if(is_array($post_types) && !empty($post_types)) {
    foreach($post_types as $type){
        if('comparison' != $type->name) {
            $all_post_type[] = $type->name;
        }
    }  
   }

    $html = '';
    $remaining_post_type = array_diff($all_post_type, $alike_saved_post_types);
   
    if(!empty($remaining_post_type) && is_array($remaining_post_type)){
      $html .= '<select name="available-posttype-list" id="available-posttype-list">';
      $html .= '<option value="">'.esc_html__('Select', 'alike').'</option>';
        foreach($remaining_post_type as $type){
            $html .='<option value="'.esc_attr($type).'">'.esc_html(ucfirst($type)).'</option>';
            }    
            $html .='</select>';
         }
        wp_send_json_success([
            'html' => $html,
        ]);
    die();
}
public function alike_compare_add_post() {

  if ( ! wp_verify_nonce( $_REQUEST['nonce'], 'builder_nonce' ) ) {
    wp_send_json_error( [
        'message' => __( 'Nonce verification failed!', 'alike' )
    ] );
    return;
   }
  $page_contnt = '
    <!-- wp:alike-block/compare-table -->
    <div class="wp-block-alike-block-compare-table"><table class="alike-dispaly-table"><!-- wp:alike-block/compare-row {"data_type":"post_keys","data_value":"post_thumbnail","custom_title":"Overviews ","display_type":"price","postType":"post","className":"wp-block-alike-block-compare-row"} /-->
    
    <!-- wp:alike-block/compare-row {"data_type":"post_keys","data_value":"post_title","custom_title":"Post Title","postType":"post","className":"wp-block-alike-block-compare-row"} /-->
    
    <!-- wp:alike-block/compare-row {"data_value":"category","custom_title":"Category ","postType":"post","className":"wp-block-alike-block-compare-row"} /--></table></div>
    <!-- /wp:alike-block/compare-table -->
  ';
  $post_title = esc_html__('Compare ').ucfirst($_POST['posttype']);
  $args = [
  'post_type' => 'comparison',
  'post_title'   => $post_title,
	'post_content' => $page_contnt,
	'post_status'  => 'publish',
	'post_author'  => get_current_user_id(),
	'meta_input'   => array(
		'alike_post_type_meta' => $_POST['posttype'],
	),
];
  $id = wp_insert_post($args);
  if($id){
    $alike_saved_post_types = get_option( 'alike_saved_post_types' );
    $alike_saved_post_types[$id] = $_POST['posttype'];
    update_option('alike_saved_post_types', $alike_saved_post_types);
  }
  $html = '';
  $alike_saved_post_types = get_option( 'alike_saved_post_types' );
  if(is_array($alike_saved_post_types) && !empty($alike_saved_post_types)){
    foreach($alike_saved_post_types as $key=>$postype) {
      $html .='<li><a href="#" class="display-iframe alike-text-decoration-none" data-url="'.esc_url(get_edit_post_link($key)).'">'.esc_html(ucfirst($postype)).'</a><a href="#" class="alike-remove-item alike-text-decoration-none" data-id="'.esc_attr($key).'"></a></li>';
    }}
    wp_send_json_success([
      'html' => $html,
     ]);

  die();
}
/**
 * Remove Post 
 */
public function alike_compare_remove_post() {

  if ( ! wp_verify_nonce( $_REQUEST['nonce'], 'builder_nonce' ) ) {
    wp_send_json_error( [
        'message' => __( 'Nonce verification failed!', 'alike' )
    ] );
    return;
   }
  
  $alike_saved_post_types = get_option( 'alike_saved_post_types' );
  unset($alike_saved_post_types[$_POST['id']]);
  $html = '';
  $error = '';
  if(wp_delete_post($_POST['id'])){
    update_option('alike_saved_post_types', $alike_saved_post_types);
    if(is_array($alike_saved_post_types) && !empty($alike_saved_post_types)){
      foreach($alike_saved_post_types as $key=>$postype) {
        $html .='<li><a href="#" class="display-iframe alike-text-decoration-none" data-url="'.esc_url(get_edit_post_link($key)).'">'.esc_html(ucfirst($postype)).'</a><a href="#" class="alike-remove-item alike-text-decoration-none" data-id="'.esc_attr($key).'"></a></li>';
      }
    }  
  }else{
    $error = esc_html__('Delete Failed,  Refresh and try again', 'alike');
  }
  wp_send_json_success([
    'html' => $html,
    'error' => $error
   ]);

  die();
}
} // end of class