<?php
if( empty( $_GET['ids'] ) ) {
  esc_html_e("No IDs to compare", "alike");
  return;
}

$show_difference = 'no';

if( isset( $_GET['show_difference'] ) ) {
  $show_difference = $_GET['show_difference'];  
}

$alike_settings = get_option('alike_settings', true);


$max_compare = ( isset( $alike_settings['max_compare'] ) ) ? $alike_settings['max_compare'] : '4';
$ids = explode(',', $_GET['ids']);
if( count( $ids ) <= $max_compare ) :

$post_types = array();
foreach ($ids as $id) {
  $post_types[] = get_post_type( $id );
}

$isHomogenous = alike_is_homogenous( $post_types );
if( !$isHomogenous ) {
  esc_html_e("Please select same post type to compare.", "alike");

  return;
}

$post_type            = current( $post_types );
$alike_data           = get_option('alike_data');

$preview_render_data  = alike_render_preview_data( $post_type, $ids, $show_difference );

$page_url             = get_the_permalink();
$get_ids              = $_GET['ids'];
$get_show_difference  = (isset($_GET['show_difference'])) ? $_GET['show_difference'] : 'no';

if( $get_show_difference == 'yes' ) {
  $new_show_difference = 'no';
} else {
  $new_show_difference = 'yes';
}
$link_url = $page_url . '?ids=' . $get_ids . '&show_difference=' . $new_show_difference;
$link_title = ( $new_show_difference == 'no' ) ? esc_html__('Show All', 'alike') : esc_html__('Show Difference', 'alike');

$posts = get_posts(array(
  'numberposts'   => 1,
  'post_type'     => 'comparison',
  'meta_key'      => 'alike_post_type_meta',
  'meta_value'    => $post_type 
));
 $template_id = isset($posts[0]->ID) ? $posts[0]->ID: '';
 if($template_id !=''){
   $compare_type = isset($_GET['show_difference']) ?  'difference-'.$_GET['show_difference'] : 'difference-no';
  ?>
   <div class="rq-alike-compare <?php echo esc_attr($compare_type); ?>">
    <a class="rq-alike-show-difference" href="<?php echo esc_url($link_url); ?>"><?php echo $link_title ?></a>
  <?php 
    $get_post = get_post($template_id);
    if ( has_blocks( $get_post->post_content ) ) {
    $blocks = parse_blocks( $get_post->post_content );
      foreach( $blocks as $block ) {
          echo render_block( $block );
      }
    }
    ?>
    </div>
    <?php 
 }else{
  esc_html_e("Dispaly Tempalte not available for this post type", "alike");
 }
?>


<?php else : // end count ids if ?>

<?php echo sprintf( esc_html__('You can compare maximum between %s items.', 'alike'), $max_compare) ?>

<?php endif; ?>



<?php
if ( !function_exists('alike_array_group_by') ) {
  function alike_array_group_by(array $arr, callable $key_selector) {
    $result = array();
    foreach ($arr as $i) {
      $key = call_user_func($key_selector, $i);
      $result[$key][] = $i;
    }  
    return $result;
  }
}

